unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dOPC, StdCtrls, Buttons, ExtCtrls, dOPCBrowseDlg;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    TopPanel: TPanel;
    Label2: TLabel;
    BDisconnect: TSpeedButton;
    bConnect: TSpeedButton;
    ServerCombo: TComboBox;
    OPCServer: TdOPCServer;
    bDebug: TButton;
    procedure ServerComboDropDown(Sender: TObject);
    procedure bConnectClick(Sender: TObject);
    procedure BDisconnectClick(Sender: TObject);
    procedure OPCServerConnect(Sender: TObject);
    procedure OPCServerDisconnect(Sender: TObject);
    procedure OPCServerError(Sender: TObject; Errorstring: String;
      var RaiseException: Boolean);
    procedure OPCServerServerShutdown(Sender: TObject; Reason: String);
    procedure bDebugClick(Sender: TObject);
    procedure OPCServerDatachange(Sender: TObject;
      ItemList: TdOPCItemList);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}


procedure TForm1.ServerComboDropDown(Sender: TObject);
begin
  if trim(ServerCombo.Items.Text) = '' then  // if no OPC Servername loaded
  begin
    Screen.Cursor := crHourGlass;
    GetOPCServers(ServerCombo.Items);        // get Servernames from registry
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.bConnectClick(Sender: TObject);
begin
   if Trim(ServerCombo.Text) <> '' then
   begin
     Memo1.Clear;
     OpcServer.ServerName     := ServerCombo.Text;   // set Servername from Combobox
     OpcServer.Active         := true;               // connect to Server
   end
   else
     ShowMessage('first select OPC Server');
end;

procedure TForm1.BDisconnectClick(Sender: TObject);
begin
  OpcServer.Active := false;                        // disconnect from server
end;

// Event OPCServer->OnConnect
procedure TForm1.OPCServerConnect(Sender: TObject);
begin
  Memo1.Lines.Add(format('connected to server %s',[OPCServer.Servername]));
end;

// Event OPCServer->OnDisConnect
procedure TForm1.OPCServerDisconnect(Sender: TObject);
begin
  OPCServer.OPCGroups[0].OPCItems.RemoveAll;  // remove all Items
  Memo1.Lines.Add(format('disconnected from server %s',[OPCServer.Servername]));
end;
// Event OPCServer->OnError
procedure TForm1.OPCServerError(Sender: TObject; Errorstring: String;
  var RaiseException: Boolean);
begin
  Memo1.Lines.Add(Errorstring);
end;

// if server disconnected -> Event OPCServer->OnServerShutdown
procedure TForm1.OPCServerServerShutdown(Sender: TObject; Reason: String);
begin
  Memo1.Lines.Add('disconnect call from opc server');
end;

procedure TForm1.bDebugClick(Sender: TObject);
var
  ItemIds : TStringlist;
  i       : integer;
begin
 ItemIds := TStringlist.Create;
 if OPCBrowseDialog(OPCServer.Browser,ItemIds) then   // user can select Items
   for i := 0 to ItemIds.Count-1 do                   // if user has items seleted
   begin
    Memo1.Lines.Add(format('Item %s insert to group %s',[ItemIds[i],OPCServer.OPCGroups[0].Name]));
    OPCServer.OPCGroups[0].OPCItems.AddItem(ItemIds[i]);  // Add Items
   end;
 ItemIds.Free;
end;

// Event OPCServer->OnDatachange
procedure TForm1.OPCServerDatachange(Sender: TObject; ItemList: TdOPCItemList);
var
  Q    : string;
  i    : integer;
begin
  for i := 0 to ItemList.Count-1 do    // more than one Items possible
  begin
    Q := 'bad';
    with ItemList[i] do
    begin
      if isGoodQuality then Q :=  'good';
      Memo1.Lines.Add(format('-> Item %s Value %s  Time: %s  Quality: %s',
                      [ItemId,ValueStr,DateTimeToStr(TimeStamp),Q]));
    end;
  end;
end;

end.
