// Simple Example for component dOPCGUI
// This example is based on Matrikon Simulation OPC Server
// You can download the server for free at: http://www.matrikon.com
// But it's a trivial matter to change to another OPC Server.
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dOPCGUI, dOPC, ExtCtrls, TeeProcs, TeEngine, Chart, Series, StdCtrls;

type
  TForm1 = class(TForm)
    OPCServer: TdOPCServer;
    OPCGUI: TdOPCGUI;
    Chart1: TChart;
    Panel1: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    cShowValue: TCheckBox;
    Series1: TFastLineSeries;
    procedure cShowValueClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Series1AfterAdd(Sender: TChartSeries; ValueIndex: Integer);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  OPC_Server  = 'Matrikon.OPC.Simulation'; // select your OPC Server
  ShowOPCItem = 'Random.Int1';             // OPC Item to Show


procedure AddValueToChart(Control: tControl; const OPCValue: OleVariant);
begin
  TChart(Control).Series[0].Add(OPCValue);  // add Value to Chart
end;

procedure TForm1.FormShow(Sender: TObject);
var
  G    : TdOPCGroup;
  Item : TdOPCItem;
begin
  RegisterGUIControl(TChart,'addvalue',AddValueToChart); // register new work procedure for TChart
  OPCServer.Servername := OPC_Server;                    // select your OPC Server
  G := OPCServer.OPCGroups.Add('test');                  // make a new group
  Item := G.OPCItems.AddItem(ShowOPCItem);               // add new Item
  OPCGUI.AddItem(Item,Chart1,'addvalue');                // Add values to Chart
  Chart1.Series[0].Add(0);                               // add Value to Chart
  OPCServer.Active := true;                              // let's go
end;


procedure TForm1.cShowValueClick(Sender: TObject);
begin
  if cShowValue.Checked then                               // show last value
  begin
    Edit1.Color := clWindow;
    OPCGUI.AddItem('test',ShowOPCItem,Edit1,'text');       // Show value in Edit
  end
  else                                                     // don't show last Value
  begin
    Edit1.Color := clSilver;
    OPCGUI.DeleteItem(Edit1,'text');                       // delete Item
    Edit1.Text := '';                                      // show nothing
  end;
end;


procedure TForm1.Series1AfterAdd(Sender: TChartSeries; ValueIndex: Integer);
const
  ShowPoints = 10;
begin
    if ValueIndex > ShowPoints then      // after 10 points -> Autoscroll
      with Sender.GetHorizAxis do        // with the Horizontal Axis...
      Begin
        Automatic := False;              // we dont want automatic scaling
        Maximum := Sender.XValues.MaxValue + 1;
        if Maximum > ShowPoints then
          Minimum := Maximum - ShowPoints;
      end;
end;

end.
